function varargout = SonoLabEchI(varargin);

% rev 1.7

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @SonoLabEchI_OpeningFcn, ...
                   'gui_OutputFcn',  @SonoLabEchI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before SonoLabEchI is made visible.
function SonoLabEchI_OpeningFcn(hObject, eventdata, handles, varargin)
% Choose default command line output for SonoLabEchI
global Snlb
Inst=instrfind;
if isempty(Inst) == 0
    fclose(Inst);
end
Snlb.f=2.5;Snlb.Prf=1000;Snlb.PlsLngt=1;
Snlb.FrqnSmpl = 100;    % 100MHz
Snlb.SndSpd=1.54;       % 1.54 m/us
Snlb.DpthStrt=20;Snlb.DpthStp=70;
Snlb.TxOn=0; 
Snlb.TrgMd = 0;Snlb.DataTrnsMd=0;Snlb.DataStrmEnbl=1;
Snlb.Mode='A';        % 'A' Amode, 'M" M-mode 
Snlb.M=0;       % record if M-Mode has been enter, if it is, it affect AxEch window size
Snlb.DcmtNmbr=4;
SnlbGrghUpdt;


Snlb.BData=[];  % to store binary echo
Snlb.BRd=1;     % store how many reads in the current line

Snlb.CrcErr=0;      %record error number in Crc, reset by start/Stop
Snlb.PntsMode=1;
Snlb.Tst=1;
Snlb.Time.Ms=0;Snlb.Time.S=0;

%--------Display control
Snlb.EnvEnbl =1;
Snlb.RfEnbl =1;
Snlb.SpctEnbl =0;

handles.output = hObject;

t=0:10e-9:10e-6;
d=t*1540000;
f=5e6;
x=sin(2*pi*f*t);
t0=rand*4000e-9;t1=(1+rand)*4000e-9;
A=rand*(t-t0).*exp(-(t-t0)/((rand+0.5)*200e-9)).*(t>t0)+rand*(t-t1).*exp(-(t-t1)/((rand+0.5)*200e-9)).*(t>t1);
y=A.*x*1e9;
y=y+rand(1,length(t))*max(y)/50;
 F=fft(y);Nf=length(F);F(round(Nf/2):Nf)=0;Ey=abs(ifft(F*2));   %get envelope
plot(handles.AxEch,d,y);
hold(handles.AxEch,'on');
plot(handles.AxEch,d,Ey,'r');hold(handles.AxEch,'off');
axis(handles.AxEch,'tight');  xlabel(handles.AxEch,'Depth: mm');
set(handles.LstMssg,'String','');

guidata(hObject, handles);

function SnlbGrghUpdt()
global Snlb
Snlb.MPnts=500;     % default is the fixed point mode round(((Snlb.DpthStp - Snlb.DpthStrt)/Snlb.SndSpd)*Snlb.FrqnSmpl);     % M-Mode line length, how many points in one line, controlled by depth
Snlb.MLngt=250;     % M-Mode length, how many lines
Snlb.MData=zeros(Snlb.MPnts,Snlb.MLngt) + 16;
Snlb.MTmrCnt=0;     % increase whenever the timer function is called.
Snlb.MLn=0;         % M line counter, when update M- mode graph
Snlb.MLnTm=zeros(1,Snlb.MLngt);         % time in second when the line received, reference to Snlb.Time.S
Snlb.MTimeSet=0;     % 1 M-mode time information set, clear after each start, or mode, depth, parameter change.
% --- Outputs from this function are returned to the command line.
function varargout = SonoLabEchI_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;



function EdtPrf_Callback(hObject, eventdata, handles)
global Snlb
Snlb.Prf=str2num(get(hObject,'String'))
fprintf(handles.CrrnCom, ['8 ' num2str(Snlb.Prf)]);
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function EdtPrf_CreateFcn(hObject, eventdata, handles)
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function BttnStart_Callback(hObject, eventdata, handles)
global Snlb
Str=get(hObject,'String');
Str=Str(1:4);
if Str=='Star'
    Snlb.TxOn=1;
    set(hObject,'String','Stop');set(hObject,'ForegroundColor','r');
    fprintf(handles.CrrnCom, 'a');
    Snlb.CrcErr=0;
    Snlb.MTmrCnt=0; % timer also used for text mode
%     Snlb.MLn=0;     % Reset M-mode line counter 
    Snlb.MTimeSet=0;     % 1 M-mode time information set, clear after each start, or mode, depth, parameter change.
    Snlb.t=[];   %debug purpose
    tic;    %save system time
else 
    Snlb.TxOn=0;
    set(hObject,'String','Start');set(hObject,'ForegroundColor',[0 0.498 0]);
%     handles.CrrnCom.Terminator='LF';
    fprintf(handles.CrrnCom, 'b');
end
guidata(hObject, handles);
% --- Executes on button press in BttnRst.
% --- Executes on button press in BttnComOpn.
function BttnComOpn_Callback(hObject, eventdata, handles)
global Snlb
handles.CrrnCom
Str=get(hObject,'String');
Str=Str(1:4);
if Str=='Open'
    if ('N' == handles.CrrnComStr(1))   % if it 'No Port'
     set(handles.LstMssg,'String','No serial port is found');  
    else
    handles.CrrnCom.InputBufferSize = 50000;
    
    handles.CrrnCom.BaudRate=115200;
     handles.CrrnCom.Terminator='LF';  %LF =10
     handles.CrrnCom.BytesAvailableFcnMode = 'terminator';
     handles.CrrnCom.BytesAvailableFcn = {'DataProcTrmn',handles};
     handles.CrrnCom.TimerFcn={'DataProcTmr', handles};
    handles.CrrnCom.TimerPeriod=0.04;   %timer period
    fopen(handles.CrrnCom);
     
    set(handles.LstMssg,'String',[handles.CrrnComStr ' is ' handles.CrrnCom.Status]);
    set(hObject,'String','Close COM');
    set(handles.BttnStrt,'Enable','on');set(handles.BttnStrt,'String','Start');set(handles.BttnStrt,'ForegroundColor',[0 0.498 0]); Snlb.TxOn=0; fprintf(handles.CrrnCom, 'b'); %stop transmit if it is on
    set(handles.EdtF,'Enable','on'); set(handles.EdtPrf,'Enable','on');set(handles.EdtPlsLngt,'Enable','on');
    set(handles.EdtDpthStrt,'Enable','on');set(handles.EdtDpthStp,'Enable','on');set(handles.EdtPnts,'Enable','on');set(handles.ChckFx,'Enable','on');
    set(handles.BttnCmmnSnd,'Enable','on');
    set(handles.BttnTrgr,'Enable','on');
    set(handles.BttnDataFrmt,'Enable','on');set(handles.BttnDataFrmt,'String','Binary'); Snlb.DataTrnsMd=0;  fprintf(handles.CrrnCom, ['d ' num2str(Snlb.DataTrnsMd)]);  % switch to text mode, to get board parameter
    set(handles.BttnDataEnbl,'Enable','on');    set(handles.BttnDataEnbl,'string','Stop Data');    Snlb.DataEnbl = '1';fprintf(handles.CrrnCom, 'f 1');
    set(handles.BttnRst,'Enable','on');
    set(handles.EdtTgc,'Enable','on');set(handles.SldrTgc,'Enable','on');set(handles.SldrGain,'Enable','on');
    end
else 
    set(hObject,'String','Open COM');
    fclose(instrfind);
     set(handles.LstMssg,'String','All ports have been closed');
     set(handles.BttnStrt,'Enable','off');set(handles.EdtF,'Enable','off');set(handles.EdtPrf,'Enable','off');set(handles.EdtPlsLngt,'Enable','off');
    set(handles.EdtDpthStrt,'Enable','off');set(handles.EdtDpthStp,'Enable','off');set(handles.EdtPnts,'Enable','off');set(handles.ChckFx,'Enable','off');
    set(handles.BttnCmmnSnd,'Enable','off');
     set(handles.BttnTrgr,'Enable','off');set(handles.BttnDataFrmt,'Enable','off');set(handles.BttnDataEnbl,'Enable','off');set(handles.BttnRst,'Enable','off');
    set(handles.EdtTgc,'Enable','off');set(handles.SldrTgc,'Enable','off');set(handles.SldrGain,'Enable','off');

end
guidata(hObject, handles);

% --- Executes on selection change in ListComCtrl.
function ListComCtrl_Callback(hObject, eventdata, handles)
global Snlb
Index = get(hObject,'Value');
List = get(hObject,'String')
Txt=List{Index};
Port=0;
if Txt(1)=='S'  % 'More ' to search more COMs
    Snlb.Err=[];
    CmLst=[];
    i=1;
    Msg={'Searching the COMs:'};
    set(handles.LstMssg,'String',Msg);
    set(handles.BttnComOpn,'String','Open COM');
     fclose(instrfind);         % close all in case any port open
    while (i<20)
            try 
                Txt1=['COM' num2str(i)];
                s=serial(Txt1);
                fopen(s);   %if fopen fail, go to catch statement
                fclose(s);
                Msg=[Msg;{['COM' num2str(i) 'Found']}];
                CmLst={Txt1};Port=1;
                handles.CrrnComStr=Txt1;  %set Com str in handles 
            catch Snlb.Err
                Msg=[Msg;{['COM' num2str(i) 'Not Exist..']}];
            end
                i=i+1
                delete(s);
    end
    if Port ==0         % no port found
        Msg=[Msg;{'Please Connect Sonoalb Board....'}];
        CmLst={'No Port'};
    end
    set(handles.LstMssg,'String',Msg);
    set(hObject,'String',[CmLst,{'Search'}]);
    set(hObject,'value',1);
end

if Txt(1)=='C'
handles.CrrnComStr=Txt;
end

handles.CrrnCom=serial(handles.CrrnComStr);
guidata(hObject, handles);


function EdtF_Callback(hObject, eventdata, handles)
global Snlb
Snlb.f=str2num(get(hObject, 'String'));
fprintf(handles.CrrnCom, ['0 ' num2str(floor(Snlb.f*100))]);
handles.Dcmt=1;
	if Snlb.f < 5
		Snlb.Dcmt = 2;
    end
	if Snlb.f < 2.5
		Snlb.Dcmt = 4;
    end
	if Snlb.f < 1.3
		Snlb.Dcmt = 8;
    end
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function EdtF_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function EdtPlsLngt_Callback(hObject, eventdata, handles)
global Snlb
Snlb.PlsLngt = str2num(get(hObject,'String'));
fprintf(handles.CrrnCom, ['1 ' num2str(Snlb.PlsLngt)]);   % update parameters
% --- Executes during object creation, after setting all properties.
function EdtPlsLngt_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in BttnTrgr.
function BttnTrgr_Callback(hObject, eventdata, handles)
global Snlb
if get(hObject,'String')=='Internal'
    Snlb.TrgrMd=0;   fprintf(handles.CrrnCom, ['c ' num2str(Snlb.TrgrMd)]);   
    set(hObject,'String','External');
elseif get(hObject,'String')=='External'
    Snlb.TrgrMd=1;   fprintf(handles.CrrnCom, ['c ' num2str(Snlb.TrgrMd)]);   
    set(hObject,'String','Internal');
end

% --- Executes on button press in BttnDataFrmt.
function BttnDataFrmt_Callback(hObject, eventdata, handles)
global Snlb
x=get(hObject,'String');
if iscell(x)
    x=x{1};
end
    Snlb.MTmrCnt=0; % timer also used for text mode
    Snlb.MLn=0;     % Reset M-mode line counter 
    Snlb.MTimeSet=0;     % 1 M-mode time information set, clear after each start, or mode, depth, parameter change.

if x(1)=='B'
    Snlb.DataTrnsMd=1;  
    fprintf(handles.CrrnCom, ['d ' num2str(Snlb.DataTrnsMd)]);  
    set(hObject,'String','Text');  
    fclose(handles.CrrnCom);
    fopen(handles.CrrnCom);

else
    Snlb.DataTrnsMd=0;   
%     handles.CrrnCom.Terminator='LF';
    fprintf(handles.CrrnCom, ['d ' num2str(Snlb.DataTrnsMd)]);
    set(hObject,'String','Binary');
    fclose(handles.CrrnCom);
    fopen(handles.CrrnCom);
end


% --- Executes on button press in BttnDataEnbl.
function BttnDataEnbl_Callback(hObject, eventdata, handles)
global Snlb
Txt=get(hObject,'string')
if Txt(3) == 'a'
    set(hObject,'string','Stop Data');
    Snlb.DataEnbl = '1';fprintf(handles.CrrnCom, 'f 1');
else
    set(hObject,'string','Start Data');
    Snlb.DataEnbl = '0';fprintf(handles.CrrnCom, 'f 0');
end

function EdtDpthStrt_Callback(hObject, eventdata, handles)
global Snlb
Snlb.DpthStrt=str2num(get(hObject,'String'));
fprintf(handles.CrrnCom, ['2 ' num2str(Snlb.DpthStrt)]);
fprintf(handles.CrrnCom, 'l');   % update parameters
% Snlb.PntsMode=0;                % depth change will cause non fixed point mode, set in microcontoller automatically
% set(handles.ChckFx, 'value',0);   %when the total data point is changed, automatically set the fixed point mode.
guidata(hObject,handles);
% --- Executes during object creation, after setting all properties.
function EdtDpthStrt_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function EdtDpthStp_Callback(hObject, eventdata, handles)
global Snlb
Snlb.DpthStp=str2num(get(hObject,'String'))
fprintf(handles.CrrnCom, ['3 ' num2str(Snlb.DpthStp)]);
% Snlb.PntsMode=0;                % depth change will cause non fixed point mode, set in microcontoller automatically
% set(handles.ChckFx, 'value',0);   %when the total data point is changed, automatically set the fixed point mode.

guidata(hObject,handles);
function EdtDpthStp_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in BttnRdPrmt.
function BttnRdPrmt_Callback(hObject, eventdata, handles)
fprintf(handles.CrrnCom, 'l');   % update parameters

function EdtPnts_Callback(hObject, eventdata, handles)
global Snlb
Snlb.Pnts=str2num(get(hObject,'String'));
handles.PntsMode=1;         % Board only send out maxmial Pnts points, drawing will be changed accordingly.
Snlb.PntsMode=1;
set(handles.ChckFx, 'value',1);   %when the total data point is changed, automatically set the fixed point mode.
fprintf(handles.CrrnCom,[ 'F ' num2str(Snlb.Pnts)]);   % update parameters
guidata(hObject,handles);


function EdtPnts_CreateFcn(hObject, eventdata, handles)
global Snlb
Snlb.PntsMode=1;         % Default is the fixed points mode.
guidata(hObject,handles);
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in ChckFx.
function ChckFx_Callback(hObject, eventdata, handles)
global Snlb
Snlb.PntsMode=get(hObject,'value'); %get the Fix Point Mode
Snlb.SpctEnbl=0;
if Snlb.PntsMode == 1 %fix points mode
    Snlb.Pnts=str2num(get(handles.EdtPnts,'String'));
    fprintf(handles.CrrnCom,[ 'F ' num2str(Snlb.Pnts)]);   % update parameters
    set(handles.ChckSpct,'value',0);
    set(handles.ChckSpct,'Enable','off');
else
              if Snlb.Mode=='A'
            set(handles.ChckSpct,'Enable','on');
            end
    fprintf(handles.CrrnCom, 'G'); % disable fix data mode
end
WinPrcs(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function AxTgc_CreateFcn(hObject, eventdata, handles)
plot(hObject,1:255);
axis(hObject,'off');


% --- Executes on slider movement.
function SldrGain_Callback(hObject, eventdata, handles)
Snlb.Gain=round(get(hObject,'value'));
fprintf(handles.CrrnCom, ['4 ' num2str(Snlb.Gain)]);   % Set TGC1 level
fprintf(handles.CrrnCom, ['6 ' num2str(Snlb.Gain)]);   %Set TGC2 Level

% --- Executes during object creation, after setting all properties.
function SldrGain_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function SldrTgc_Callback(hObject, eventdata, handles)
Snlb.TGC=round(get(hObject,'value'));
fprintf(handles.CrrnCom, ['5 ' num2str(Snlb.TGC)]);   % Set TGC1 slope
fprintf(handles.CrrnCom, ['7 ' num2str(Snlb.TGC)]);   %Set TGC2 slope

% --- Executes during object creation, after setting all properties.
function SldrTgc_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function EdtTgc_Callback(hObject, eventdata, handles)
% --- Executes during object creation, after setting all properties.
function EdtTgc_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in BttnMode.
function BttnMode_Callback(hObject, eventdata, handles)
global Snlb
Txt=get(hObject,'string');
if Txt(1) == 'A'
    set(hObject,'string','M-Mode');
    Snlb.Mode = 'A';
    set(handles.AxSpct,'visible','on');set(handles.ChckSpct,'Enable','off');
    set(handles.SldrMdUD,'visible','off');  set(handles.SldrMdLR,'visible','off');  set(handles.BttnMdClr,'visible','off');
else
    set(hObject,'string','A-Mode');
    Snlb.SpctEnbl =0; set(handles.ChckSpct,'value',0); %disable spectrum
    set(handles.ChckSpct,'Enable','off');
    Snlb.Mode = 'M'; 
    Snlb.Time.S=0; Snlb.MLn=0; Snlb.MData(:,:)=0; %rest sonolab time
    Snlb.Pnts=500;set(handles.EdtPnts,'String',num2str(Snlb.Pnts));  % force to fixed 500 pnts Mode to keep image speed
    fprintf(handles.CrrnCom,[ 'F ' num2str(Snlb.Pnts)]);   % update parameters
    set(handles.SldrMdUD,'visible','on');  set(handles.SldrMdLR,'visible','on');  set(handles.BttnMdClr,'visible','on');
end
WinPrcs(handles);
function WinPrcs(handles)
global Snlb
    if Snlb.M == 0  
    Snlb.AxEchPA =  get(handles.AxEch,'position');Snlb.M=1; 
    Snlb.AxEchPM=Snlb.AxEchPA; 
    Snlb.AxEchPM(4)=Snlb.AxEchPM(4)/2;
    Snlb.AxEchPM(2)=Snlb.AxEchPM(2)+Snlb.AxEchPM(4);
    end
    if (Snlb.Mode == 'A')&&(Snlb.SpctEnbl==1)   % two windows
        set(handles.AxEch,'position',Snlb.AxEchPM);
        set(handles.AxSpct,'visible','on');
    else
       set(handles.AxEch,'position',Snlb.AxEchPA);
       cla(handles.AxSpct);
       set(handles.AxSpct,'visible','off');  
    end
    

% --- Executes on slider movement.
function SldrMdUD_Callback(hObject, eventdata, handles)
UD=get(hObject,'Value')
LR=get(handles.SldrMdLR,'value');
view(handles.AxEch,LR,UD);
global Snlb
Snlb.UD=get(hObject,'Value');
% --- Executes during object creation, after setting all properties.
function SldrMdUD_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
global Snlb
Snlb.UD=get(hObject,'Value');

% --- Executes on slider movement.
function SldrMdLR_Callback(hObject, eventdata, handles)
LR=get(hObject,'Value');
UD=get(handles.SldrMdUD,'value');
view(handles.AxEch,LR,UD);
global Snlb
Snlb.LR=get(hObject,'Value');

% --- Executes during object creation, after setting all properties.
function SldrMdLR_CreateFcn(hObject, eventdata, handles)

global Snlb
Snlb.LR=get(hObject,'Value');
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end







% --- Executes on button press in ChckEnv.
function ChckEnv_Callback(hObject, eventdata, handles)
global Snlb;
Snlb.EnvEnbl = get(hObject,'value');
if Snlb.EnvEnbl == 0
    Snlb.RfEnbl =1;
    set(handles.ChckRF,'value',1);
end

% --- Executes on button press in ChckRF.
function ChckRF_Callback(hObject, eventdata, handles)
global Snlb;
Snlb.RfEnbl = get(hObject,'value');
if Snlb.RfEnbl == 0
    Snlb.EnvEnbl=1;
    set(handles.ChckEnv,'value',1);
end
WinPrcs(handles);
% --- Executes on button press in ChckSpct.
function ChckSpct_Callback(hObject, eventdata, handles)
global Snlb;
Snlb.SpctEnbl = get(hObject,'value');
WinPrcs(handles)
% --- Executes on button press in BttnMdClr.
function BttnMdClr_Callback(hObject, eventdata, handles)
Txt=get(hObject,'string');
if Txt(1) =='G'
colormap(handles.AxEch,gray);
set(hObject,'string', 'Color');
else
    colormap(handles.AxEch,'default');
    set(hObject,'string', 'GrayScale');
end
function BttnRst_Callback(hObject, eventdata, handles)
global Snlb
Snlb.Time.S=0; Snlb.MLn=0; Snlb.MData(:,:)=0; %rest sonolab time
guidata(hObject,handles);
 % --- Executes during object creation, after setting all properties.
function ListComCtrl_CreateFcn(hObject, eventdata, handles)
global Snlb
Inst=instrfind;
if isempty(Inst) == 0
    fclose(Inst);
    for i=1:length(Inst)
        delete(Inst(i));    % deleter existing object to free memory
    end
end
Snlb.Err=[];
CmLst=[];
i=1;
while (length(CmLst)==0)&&(i<20)
        try 
        Txt=['COM' num2str(i)];
        s=serial(Txt);
        fopen(s);    fclose(s); %if fopen fail, go to catch statement
         CmLst={Txt};
    catch Snlb.Err
        end
    i=i+1
         delete(s);
end

if length(CmLst) ==0
  CmLst={'No Port'};
end

set(hObject,'String',[CmLst,{'Search'}]);
set(hObject,'value',1);
Index = get(hObject,'Value');
List = get(hObject,'String');
handles.CrrnComStr=List{Index};
handles.CrrnCom=serial(handles.CrrnComStr);
guidata(hObject, handles);

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in LstMssg.
function LstMssg_Callback(hObject, eventdata, handles)
function LstMssg_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function EdtCmmn_Callback(hObject, eventdata, handles)
handles.CmdStr=get(hObject,'string')
%fprintf(handles.CrrnCom, handles.CmdStr);
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function EdtCmmn_CreateFcn(hObject, eventdata, handles)

handles.CmdStr=get(hObject,'string');
guidata(hObject, handles);

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in BttnCmmnSnd.
function BttnCmmnSnd_Callback(hObject, eventdata, handles)
fprintf(handles.CrrnCom, handles.CmdStr);

guidata(hObject, handles);
% --- Executes on button press in BttnClear.
function BttnClear_Callback(hObject, eventdata, handles)
t=0:10e-9:10e-6;
d=t*1540000;
f=5e6;
x=sin(2*pi*f*t);
t0=rand*4000e-9;t1=(1+rand)*4000e-9;
A=rand*(t-t0).*exp(-(t-t0)/((rand+0.5)*200e-9)).*(t>t0)+rand*(t-t1).*exp(-(t-t1)/((rand+0.5)*200e-9)).*(t>t1);
y=A.*x*1e9;
y=y+rand(1,length(t))*max(y)/50;
 F=fft(y);Nf=length(F);F(round(Nf/2):Nf)=0;Ey=abs(ifft(F*2));   %get envelope
plot(handles.AxEch,d,y);
hold(handles.AxEch,'on');
plot(handles.AxEch,d,Ey,'r');hold(handles.AxEch,'off');
axis(handles.AxEch,'tight');  xlabel(handles.AxEch,'Depth: mm');
set(handles.LstMssg,'String','');
